package com.emperador.exoplayer_example

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.os.Bundle
import com.emperador.exoplayer.service.MusicService

import io.flutter.app.FlutterActivity
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugins.GeneratedPluginRegistrant
import java.security.KeyManagementException
import java.security.NoSuchAlgorithmException
import javax.net.ssl.HttpsURLConnection
import javax.net.ssl.SSLContext
import javax.net.ssl.TrustManager
import javax.net.ssl.X509TrustManager
import java.security.cert.X509Certificate


class MainActivity : FlutterActivity() {

    companion object {
        const val CHANNEL = "exoplayer"
    }

    lateinit var channel : MethodChannel

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        channel = MethodChannel(flutterView, CHANNEL)

        val trustAllCerts = arrayOf<TrustManager>(object : X509TrustManager {

            override fun checkClientTrusted(p0: Array<out X509Certificate>?, p1: String?) {

            }

            override fun checkServerTrusted(p0: Array<out X509Certificate>?, p1: String?) {
            }

            override fun getAcceptedIssuers(): Array<X509Certificate?> {
                return emptyArray()
            }

        })
        try {
            val sc = SSLContext.getInstance("TLS")
            sc.init(null, trustAllCerts, java.security.SecureRandom())
            HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory())
        } catch (e: KeyManagementException) {
            e.printStackTrace()
        } catch (e: NoSuchAlgorithmException) {
            e.printStackTrace()
        }

        GeneratedPluginRegistrant.registerWith(this)
    }

    // pasa el intent al plugin de flutter
   private val mainReceiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context, intent: Intent) {
            channel.invokeMethod(intent.action!!, intent.getStringExtra("state"))
        }
    }

    override fun onStart() {
        super.onStart()
        registerReceiver(mainReceiver, IntentFilter(MusicService.PLAYBACK_STATE))
    }

    override fun onDestroy() {
        registerReceiver(mainReceiver, IntentFilter(MusicService.PLAYBACK_STATE))
        super.onDestroy()
    }
}
