import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/services.dart';

class Exoplayer {
  static const TYPE_PROGRESSIVE = 0;
  static const TYPE_HLS = 1;

  static const MethodChannel _channel = const MethodChannel('exoplayer');

  static startService(int type, String url) async {
    var arguments = {'type': type, 'url': url};
    _channel.invokeMethod('startService', arguments);
  }

  static play() {
    _channel.invokeMethod('play');
  }

  static stopService() {
    _channel.invokeMethod('stopService');
  }

  static pause() {
    _channel.invokeMethod('pause');
  }


}
